(function() {
	'use strict';

	angular
		.module('psa.app.run', [
		])

		.run(Run);
		Run.$inject = ['$rootScope', '$log', 'Auth', '$state', '$ionicHistory', '$ionicPlatform', 'amMoment'];

	/* @ngInject */
	function Run($rootScope, $log, Auth, $state, $ionicHistory, $ionicPlatform, amMoment) {
		$log.log('PSA app');

	  $ionicPlatform.ready(function() {
			var notificationOpenedCallback = function(jsonData) {
		    console.log('notificationOpenedCallback: ' + JSON.stringify(jsonData));
		    var additionalData = jsonData.notification.payload.additionalData;
		    if (additionalData) {
		    	if (additionalData.orcamentoId) {
		    		//{"assessor":"Fulano de Tal","descricao":"Uma palestra do balacobaco","orcamentoId":"666","cidade":"Porto Alegre","email":"jannone@gmail.com","titulo":"Palestra interessante"}
						localStorage.setItem("orcamento", JSON.stringify(additionalData));
						console.log("OPENING ORCAMENTO");
						$state.go("app.menu.availability", {talkId: additionalData.orcamentoId });
		    	}
		    }
		    // if (jsonData.additionalData && jsonData.additionalData.url) {
		    // 	$cordovaInAppBrowser.open(jsonData.additionalData.url, '_blank')
			   //    .then(function(event) {
			   //      // success
			   //    })
			   //    .catch(function(event) {
			   //      // error
			   //    });
		    // }
		  };

		  if (window.plugins && window.plugins.OneSignal) {
			  window.plugins.OneSignal
			    .startInit("cb8376d5-2d79-40e5-bf20-4832a4be05f1", "588271197374")
				  .inFocusDisplaying(window.plugins.OneSignal.OSInFocusDisplayOption.Notification)
			    .handleNotificationOpened(notificationOpenedCallback)
			    .endInit();
			}
		 });
		
		amMoment.changeLocale('de');

		$rootScope.$on('$stateChangeError', function (event, to, toP, from, fromP, error) {
			switch (error) {
				case 'AUTH_REQUIRED':
					$state.go('welcome');
					break;
			}
		});
		Auth.$onAuthStateChanged(function (a, b) {
			if (a || b) {
				if (!$state.current.name.indexOf('app') >= 0) {
					$ionicHistory.nextViewOptions({
						historyRoot: true,
						disableAnimate: true,
						expire: 300
					});
					$state.go('app.menu.talks');
				}
			} else {
				if ($state.current.name.indexOf('app') >= 0) {
					$ionicHistory.nextViewOptions({
						historyRoot: true,
						disableAnimate: true,
						expire: 300
					});
					$state.go('welcome');
				}
			}
		});
	}

})();
