(function() {
	'use strict';

	angular
		.module('psa.attendants.controller', [])
		.controller('AttendantsController', AttendantsController);

	AttendantsController.$inject = ['Attendants', 'Talk', '$ionicLoading', '$stateParams'];

	/* @ngInject */
	function AttendantsController(Attendants, Talk, $ionicLoading, $stateParams) {
		var vm = this;
		vm.title = 'AttendantsController';

		activate();

		////////////////

		function getTalk() {
			var talkId = $stateParams.id;
			vm.talk = Talk(talkId);
		}

		function getAttendants() {
			$ionicLoading.show({
				template: 'Carregando participantes...'
			});
			var talkId = $stateParams.id;
			vm.list = Attendants(talkId);
			vm.list.$loaded().finally(function () {
				console.log(vm.list);
				$ionicLoading.hide();
			});
		}

		function activate() {
			getTalk();
			getAttendants();
		}
	}
})();
