(function() {
	'use strict';

	angular
		.module('psa.attendants.factory', [])
		.factory('Attendants', Attendants);

	Attendants.$inject = ['$firebaseArray', 'User'];

	/* @ngInject */
	function Attendants($firebaseArray, User) {
		return function (talkId, limit) {
			var talkRef = firebase.database().ref().child('talks').child(talkId).child('attendants');
			if (!isNaN(limit)) {
				talkRef = talkRef.limitToLast(limit);
			}

			return $firebaseArray.$extend({
				$$added: function (snap) {
					var id = snap.key;
					return new User(id);
				},
				$$removed: function (snap) {
					this.$getRecord(snap.key()).destroy();
				},
				$add: readOnly,
				$save: readOnly
			})(talkRef);

			function readOnly() { 
				throw new Error('This is a read only list'); 
			}

		};
	}
})();
