(function() {
	'use strict';

	angular
		.module('psa.auth.welcome.controller', [])
		.controller('WelcomeController', WelcomeController);

	WelcomeController.$inject = ['$cordovaFacebook', 'Auth', 'User', 'UserTags', '$q', 'FacebookAPIService', '$state'];

	/* @ngInject */
	function WelcomeController($cordovaFacebook, Auth, User, UserTags, $q, FacebookAPIService, $state) {
		var vm = this;
		vm.title = 'WelcomeController';
		vm.loginFacebook = loginFacebook;

		// window.plugins.OneSignal.getTags(function(data) {
		// 	console.log("TAGS", JSON.stringify(data));
		// });

		function loginFacebook() {
			var _user, authData;
			$cordovaFacebook.login(["public_profile", "email", "user_likes"]).then(function(result) {
				//console.log("FB OK", JSON.stringify(result, null, 3));
				FacebookAPIService.setAccessToken(result.authResponse.accessToken);
				var credential = firebase.auth.FacebookAuthProvider.credential(result.authResponse.accessToken);
				return Auth.$signInWithCredential(credential);
			}).then(function(_authData) {
				authData = _authData;

				// grab user picture
				return FacebookAPIService.get("/me/picture", {
					redirect: false, 
					type: "normal"
				});

			}).then(function(mePicture) {
          //console.log(JSON.stringify(authData));
          var uid = authData.uid;
          var name = authData.displayName;
          var email = authData.email;
          var photoURL = mePicture.data.data.url;

          // set onesignal user tag
          window.plugins.OneSignal.sendTag("_userId", uid);

          // capture user FB likes
          var _likes;
					FacebookAPIService.getAllPages("/me/likes").then(function(pages) {
						var likeParts = pages.map(function(page) {
							return page.data.data.map(function(like) {
								return like.name;
							});
						});
						_likes = [].concat.apply([], likeParts);
						
						var tags = UserTags(uid);
						tags.tags = _likes;
						return tags.$save();
					}).then(function() {
						var tagmap = {};
						_likes.forEach(function(like) {
							tagmap[like] = 1;
						});
						window.plugins.OneSignal.sendTags(tagmap);

					}, function(err) {
						console.log("FB LIKES ERROR", JSON.stringify(err));
					});

          var user = User(uid);
					return user.$loaded().then(function() {
						//console.log(JSON.stringify(user, null, 3));
						user.email = email;
						user.name = name;
						user.pictureUrl = photoURL;
						_user = user;
						return user.$save();
					}, function(err) {
						console.log("ERROR LOADING USER", JSON.stringify(err));
						return $q.reject(err);
					});
					// UploadImage.uploadImage(vm.picture, 'pictures', firebaseUser.uid, function () {
					// });
			}).then(function() {
				console.log("FB SUCCESS");
				if (!_user.email || !_user.phone) {
					$state.go("signup-fb");
				}
			}, function (error) {
				console.log("FB ERROR", JSON.stringify(error));
			});
		}

		activate();

		////////////////

		function activate() {		
		}
	}
})();
