(function() {
	'use strict';

	angular
		.module('psa.availability.controller', [])
		.controller('AvailabilityController', AvailabilityController);

	AvailabilityController.$inject = ['Talk', '$stateParams', '$state', '$ionicLoading', '$ionicPopup', '$http'];

	/* @ngInject */
	function AvailabilityController(Talk, $stateParams, $state, $ionicLoading, $ionicPopup, $http) {
		var vm = this;

		vm.available = available;
		vm.unavailable = unavailable;

		activate();

		////////////////

		function answer(available) {
			var data = {
				id: vm.talk.psaid,
				orcamentoId: vm.talk.orcamentoId,
				answer: available
			};
			console.log(JSON.stringify(data));
      return $http({
        method: "POST",
        url: "http://profissionaissa.com/api/answer_invite.php",
        //url: "/psa/api/answer_invite.php",
        data: JSON.stringify(data),
        headers: {
          "Content-Type": "application/json"
        }
      }).success(function(data, status) {
      	console.log("AV", JSON.stringify(data));
      }).error(function(err) {
        console.log("AV ERR", JSON.stringify(err));
      });
		}

		function available() {
			answer(true);
			$state.go('app.menu.talks');
		}

		function unavailable() {
			answer(false);
			$state.go('app.menu.talks');
		}

		function talkNotFound() {
			var popup = $ionicPopup.alert({
				title: 'Desculpe',
				template: 'Não foi possível encontrar esta palestra',
				okType: 'button-energized'
			});
			popup.then(function () {
				$state.go('app.menu.talks');
			});
		}

		function getTalk() {
			var data = JSON.parse(localStorage.getItem("orcamento"));
			if (data) {
				console.log(JSON.stringify(data, null, 3));
				vm.talk = data;
			}
			/*
			$ionicLoading.show({
				template: 'Carregando palestra...'
			});
			var talkId = $stateParams.talkId;
			console.log(!talkId || !talkId.length);
			if (!talkId || !talkId.length) {
				$ionicLoading.hide();
				return talkNotFound();
			}
			vm.talk = Talk(talkId);
			vm.talk.$loaded().then(function () {
				if (!vm.talk || !vm.talk.title || !vm.talk.$id || !vm.talk.description) {
					throw new Error('Talk not found');
				} 
				vm.time = new Date(Number(vm.talk.startHour));
			}).catch(function() {
				return talkNotFound();
			}).finally(function () {
				$ionicLoading.hide();
			});
			*/
		}

		function activate() {
			getTalk();
		}
	}
})();
