(function() {
	'use strict';

	angular
		.module('psa.filters.duration', [])
		.filter('duration', duration);

	function duration() {
		return durationFilter;

		////////////////

		function durationFilter(time) {
			var timeToReturn = '';
			if (time) {
				time = Number(time);
				if (!isNaN(time)) {
					var hours = Math.floor(time/60);
					var minutes = time % 60;
					if (hours === 1) {
						timeToReturn += hours + ' hora';
					}
					else if (hours > 1) {
						timeToReturn += hours + ' horas';
					}
					if (hours > 0 && minutes > 0) {
						timeToReturn += ' e ';
					}
					if (minutes > 0) {
						timeToReturn += minutes + ' minutos';
					}
				}
			}
			return timeToReturn;
		}
	}

})();
