(function() {
	'use strict';

	angular
		.module('psa.notifications.run', [
		])

		.run(Run);
		Run.$inject = ['$log', '$ionicPlatform', '$cordovaDevice', '$cordovaPush', 'Auth', 'User', 'NotificationsService'];

	/* @ngInject */
	function Run($log, $ionicPlatform, $cordovaDevice, $cordovaPush, Auth, User, NotificationsService) {
		
		activate();

		////////////////////

		function configurePush() {
			$ionicPlatform.ready(function () {
				var push = $cordovaPush.init({
					android: {
						senderID: '523489185449'
					},
					ios: {
						alert: 'true',
						badge: false,
						sound: 'false'
					},
					windows: {}
				});
				if (!push.error) {
					push.on('registration', onRegistration);
					push.on('notification', onNotification);
				}
			});
		}

		function onRegistration(data) {
			$ionicPlatform.ready(function () {
				$log.log(data, $cordovaDevice);
				var platformName = $cordovaDevice.device.platform.toLowerCase();
				Auth.$onAuthStateChanged(function (auth) {
					if (auth) {
						var user = User(auth.uid);
						user.$loaded().then(function () {
							for (var t in user.deviceTokens) {
								var token = user.deviceTokens[t];
								if (token.platform === platformName && data.registrationId === token.token) {
									return;
								}
							}
							if (!user.deviceTokens) {
								user.deviceTokens = [];
							}
							user.deviceTokens.push({
								token: data.registrationId,
								platform: platformName
							});
							user.$save();
						});
					}
				});
			});
		}

		function onNotification(data) {
			var seen;
			Auth.$onAuthStateChanged(function () {
				if (seen) {
					return;
				}
				seen = true;
				if (data.additionalData && data.additionalData.action && NotificationsService[data.additionalData.action]) {
					NotificationsService[data.additionalData.action](data.additionalData);
				}
			});
		}

		function activate() {
			configurePush();
		}
	}

})();
