(function() {
	'use strict';

	angular
		.module('psa.notifications.service', [])
		.factory('NotificationsService', NotificationsService);

	NotificationsService.$inject = ['$state', '$ionicPlatform'];

	/* @ngInject */
	function NotificationsService($state, $ionicPlatform) {
		var service = {
			newArticleReceived: newArticleReceived,
			requestForAvailability: requestForAvailability,
			speakerAnswered: speakerAnswered
		};
		return service;

		////////////////

		function newArticleReceived(data) {
			$ionicPlatform.ready(function () {
				cordova.InAppBrowser.open(data.link, '_blank');
			});
		}

		function requestForAvailability(data) {
			$state.go('app.menu.availability', {
				title: data.title,
				description: data.description,
				talkId: data.talkId
			});
		}

		function speakerAnswered(data) {
			$state.go('app.menu.questions', {
				id: data.talkId
			});
		}

	}
})();
