(function() {
	'use strict';

	angular
		.module('psa.questions.factory', [])
		.factory('Questions', Questions);

	Questions.$inject = ['$firebaseArray', 'User', '$firebaseObject'];

	/* @ngInject */
	function Questions($firebaseArray, User, $firebaseObject) {
		return function (talkId, limit) {
			var ref = firebase.database().ref().child('talks').child(talkId).child('questions');
			if (!isNaN(limit)) {
				ref = ref.limitToLast(1);
			}			
			return $firebaseArray.$extend({
				$$added: function (snap) {
					var obj = {};
					obj.obj = new $firebaseObject(snap.ref);
					obj.user = new User(snap.child('user').val());
					console.log(obj.user);
					return obj;
				}
			})(ref);
		};
	}
})();
