(function() {
    'use strict';

    angular
        .module('psa.shared.email.service', [])
        .service('EmailService', ['$q', '$http', EmailService]);

    function EmailService($q, $http) {
        var config = {
            sendgrid: {
                api_key: "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",
                from: "contato@profissionaissa.com"
            }
        }

        var api_key = '';
        var from = '';

        var self = {
            init: function() {
                api_key = config.sendgrid.api_key;
                from = config.sendgrid.from;
            },
            send: function(recipients, template_id, substitutions, replyTo) {
                if (!api_key) {
                    self.init();
                }
                var d = $q.defer();

                var email = {
                    "personalizations": [
                        {
                            "to": [],
                            "substitutions": substitutions || {}
                        }
                    ],
                    "from": {
                        "email": from
                    },
                    "template_id": template_id
                    
                    // {
                    //     "name": 
                    //     "talk":
                    //     "location":
                    //     "date":
                    // }
                    // "content": [
                    //     {
                    //         "type": "text/html",
                    //         "value": content
                    //     }
                    // ]
                };

                if (replyTo) {
                    email.reply_to = replyTo;
                }

                email.personalizations[0].to = recipients.map(function(r) {
                    return {
                        email: r.email,
                        name: r.name || r.email
                    };
                });

                //console.log(JSON.stringify(JSON.stringify(email)));

                $http({
                    method: "POST",
                    url: "https://api.sendgrid.com/v3/mail/send",
                    //url: "/sendgrid/v3/mail/send",
                    data: JSON.stringify(email),
                    headers: {
                        "Authorization": "Bearer " + api_key,
                        "Content-Type": "application/json"
                    },
                    timeout: 10000
                }).success(function(data, status) {
                    d.resolve(data);
                }).error(function(err) {
                    d.reject(err);
                });

                return d.promise;
            }
        };
        
        return self;
    }

}());

