(function() {
	'use strict';

	angular
		.module('psa.lecturing.controller', [])
		.controller('LecturingController', LecturingController);

	LecturingController.$inject = ['User', 'Talks', '$ionicLoading', '$q', 'auth', '$scope', '$ionicBackdrop', '$timeout', '$state'];

	/* @ngInject */
	function LecturingController(User, Talks, $ionicLoading, $q, auth, $scope, $ionicBackdrop, $timeout, $state) {
		var vm = this;

		vm.loading = true;
		vm.empty = empty;

		$scope.$on('$ionicView.enter', activate);

		////////////////

		function getKey(type) {
			return type + 'Loaded';
		}

		function empty(type) {
			var key = getKey(type);
			if (!vm[key]) {
				return true;
			}
			return vm[type].length === 0;
		}

		function loaded(type) {
			var key = getKey(type);
			vm[key] = true;
		}

		function getTalksInfo() {
			vm.loading = true;
			$ionicLoading.show({
				template: 'Carregando palestras...'
			});
			vm.available = Talks(auth.uid, 'asSpeaker');
			vm.available.$loaded().then(function() {
				loaded('available');
				$ionicLoading.hide();
				vm.loading = false;
			});
		}

		function activate() {
			getTalksInfo();
		}
	}
})();
