(function() {
	'use strict';

	angular
		.module('psa.talk.service', [])
		.factory('TalkService', TalkService);

	TalkService.$inject = ['$window'];

	/* @ngInject */
	function TalkService($window) {
		var fns = [];
		var FAVORITE_TALK_LS_STRING = 'FAVORITE_TALK_LS_STRING';
		var service = {
			onLastTalkChanged: onLastTalkChanged,
			getLastTalk: getLastTalk,
			setLastTalk: setLastTalk
		};
		return service;

		////////////////

		function onLastTalkChanged(fn) {
			fns.push(fn);
			fn(getLastTalk());
		}

		function getLastTalk() {
			var talk = $window.localStorage.getItem(FAVORITE_TALK_LS_STRING);
			if (talk) {
				talk = JSON.parse(talk);
				return talk;
			}
			return undefined;
		}

		function setLastTalk(talk) {
			$window.localStorage.setItem(FAVORITE_TALK_LS_STRING, JSON.stringify(talk));
			for (var f in fns) {
				var fn = fns[f];
				fn(getLastTalk());
			}
			return talk;
		}
	}
})();