(function() {
	'use strict';

	angular
		.module('psa.talks.factory', [])
		.factory('Talks', Talks);

	Talks.$inject = ['$firebaseArray', '$firebaseObject'];

	/* @ngInject */
	function Talks($firebaseArray, $firebaseObject) {
		return function (uuid, type) {
			if (type === "available") {
				var ref = firebase.database().ref().child('talks').orderByChild("available").equalTo(true);
				return $firebaseArray(ref);
			}
			var userRef = firebase.database().ref().child('users').child(uuid).child('talks').child(type);
			return $firebaseArray.$extend({
				$$added: function (snap) {
					var ref = firebase.database().ref().child('talks').child(snap.key);
					return new $firebaseObject(ref);
				},
				$$updated: function (snap) {},
				$$removed: function (snap) {
					this.$getRecord(snap.key()).destroy();
				},
				$add: readOnly,
				$save: readOnly
			})(userRef);

			function readOnly() { 
				throw new Error('This is a read only list'); 
			}

		};
	}
})();
